> For the complete documentation index, see [llms.txt](https://docs.ariaprotocol.xyz/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ariaprotocol.xyz/technical-docs/contract-docs/legal/modules/license.md).

# License

**Inherits:** ILicense, AccessControlInternal, EIP712

## State Variables

### SIGN\_LICENSE\_TYPEHASH

```solidity
bytes32 private constant SIGN_LICENSE_TYPEHASH = keccak256("SignLicense(string licenseURI,bytes32 contentURIHash)");
```

## Functions

### signLicense

User

```solidity
function signLicense(bytes calldata signature) external override;
```

### revokeCurrentSignature

Admin

```solidity
function revokeCurrentSignature(address account) external onlyRole(AccessControlStorage.DEFAULT_ADMIN_ROLE);
```

### setLicenseURI

```solidity
function setLicenseURI(string memory uri, bytes32 contentHash)
    external
    onlyRole(AccessControlStorage.DEFAULT_ADMIN_ROLE);
```

### licenseVersion

```solidity
function licenseVersion() public view override returns (uint256);
```

### licenseURIOf

```solidity
function licenseURIOf(uint256 version) public view override returns (string memory);
```

### licenseURI

```solidity
function licenseURI() external view override returns (string memory);
```

### contentURIHash

```solidity
function contentURIHash() external view override returns (bytes32);
```

### hasSignedCurrentLicense

```solidity
function hasSignedCurrentLicense(address account) external view override returns (bool);
```

### \_buildDigest

```solidity
function _buildDigest() internal view virtual returns (bytes32);
```

### \_domainNameAndVersion

```solidity
function _domainNameAndVersion() internal view override returns (string memory name, string memory version);
```

### \_domainNameAndVersionMayChange

```solidity
function _domainNameAndVersionMayChange() internal pure override returns (bool result);
```

### \_setLicenseURI

```solidity
function _setLicenseURI(string memory uri, bytes32 contentHash) internal;
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ariaprotocol.xyz/technical-docs/contract-docs/legal/modules/license.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
